Redmine - Patch #32523

Replace for’ loops with forEach’ in buildFilterRow function
2019-11-27 16:52 - Stéphane Parunakian
Priority: Normal Due date:
Target version: 6.0.0

Description

Hi,

When building a query on the /issues page, if you use a filter on users (assigned to, author, etc.) and you have a lot of them, the
browser freezes for a few moments. This can be improved by slightly modifying the JavaScript running on the page.

In the public/javascripts/application.js, a lot of "for" loops use var.length in their statements, which is evaluated at each loop.
The attached patch adds, for each loop, a var assignment just before the loop, which is used in the statement.
Performances are greatly improved on Firefox and Chromium.

Regards

Associated revisions

Revision 23046 - 2024-09-09 16:31 - Go MAEDA
Replace “for" loops with “forEach™ in “buildFilterRow" function (#32523).

Patch by Yuichi HARADA (user:yui.har).
Revision 23054 - 2024-09-12 03:55 - Go MAEDA
Revert r23046 (#32523).

The change broke filters.

Revision 23102 - 2024-10-04 00:36 - Go MAEDA
Replace “for" loops with “forEach™ in “buildFilterRow" function (#32523).

Patch by Yuichi HARADA (user:yui.har).

History

#1 - 2019-11-29 10:57 - Stéphane Parunakian
- File javascript-perf2.diff added

There is a typo in the previous patch. Here is the corrected version.

#2 - 2019-12-10 04:20 - Yuichi HARADA

- File execution_speed_measurement.png added

| changed the for statements of javascript-perf2.diff to forEach.
https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Global_Objects/Array/forEach

| think forEach is better because the loop counter variable becomes unnecessary.

diff --git a/public/javascripts/application.js b/public/javascripts/application. js
index e€4e902d9c..354185c03 100644
—-—— a/public/javascripts/application. js
+++ b/public/javascripts/application. js
@@ -165,7 +165,7 @@ function buildFilterRow(field, operator, values) {
if (!filterOptions) return;
var operators = operatorByType[filterOptions['type'll;
var filterValues = filterOptions|['values'];
- wvar 1, select;
+ var select;

var tr = $('<tr class="filter">"').attr('id', 'tr_'+4+fieldId).html (
'<td class="field"><input checked="checked" id="cb_'+fieldId+'" name="f[]" value="'+field+'" type="checkb
ox"><label for="cb_'+fieldId+'"> '+filterOptions['name']+'</label></td>"' +
@@ -175,11 +175,11 @@ function buildFilterRow (field, operator, values) {
filterTable.append(tr);

select = tr.find('td.operator select');
- for (i = 0; 1 < operators.length; i++) {
= var option = $('<option>').val (operators[i]) .text (operatorLabels[operators[i]]);
= if (operators[i] == operator) { option.prop('selected',6 true); }
+ operators.forEach (function (op) {
+ var option = $('<option>'").val (op).text (operatorLabels[op]);
+ if (op == operator) { option.prop('selected', true); }

select.append (option);
-}
+ N
select.change (function () { toggleOperator (field); });

switch (filterOptions|['type']l) {
@@ -193,8 +193,7 Q@ function buildFilterRow(field, operator, values) {
)i

select = tr.find('td.values select');
if (values.length > 1) { select.attr('multiple', true); }
= for (i = 0; i < filterValues.length; i++) {
= var filterValue = filterValues[i];
+ filterValues.forEach (function(filterValue) {
var option = $('<option>"');

if ($.isArray(filtervValue)) {
option.val (filterValue[l]) .text (filtervValuel[0]);
@@ -209,7 +208,7 @@ function buildFilterRow (field, operator, values) {
if ($.inArray(filtervValue, values) > -1) {option.prop('selected', true);}
}
select.append (option);
= }
+ 1)
break;
case "date":
case "date_past":
@@ -236,13 +235,12 @@ function buildFilterRow(field, operator, values) {
)i
S ('"#values_'+fieldId) .val (values[0]);
select = tr.find('td.values select');
= for (1 = 0; 1 < filterValues.length; i++) {
= var filterValue = filterValues[i];
+ filterValues.forEach (function(filterValue) {
var option = $('<option>'");
option.val (filterValue[l]) .text (filtervValuel[0]);
if (values[0] == filterValue[l]) { option.prop('selected', true); }
select.append(option);
N }
+ b
break;
case "integer":
case "float":

| added 200 users to the project member and compared the execution speed of the Author(author_id) filter. However, there is no significant difference
in execution speed.
execution_speed_measurement.png
| measured using performance.now() .
https://developer.mozilla.org/en-US/docs/Web/API/Performance/now

Firefox Chrome Safari Edge IE11
#3 - 2019-12-12 13:05 - Go MAEDA

According to #32523#note-2, the patches don't improve the performance so much. | wonder if we should merge any of patches.

#4 - 2024-09-05 12:21 - Go MAEDA
- File 32523-note-2.patch added

#5 - 2024-09-05 22:38 - Go MAEDA

- Subject changed from Improve javascript performances on query edition to Replace “for™ loops with “forEach’ in buildFilterRow function

- Category changed from Performance to Code cleanup/refactoring

- Target version set to 6.0.0

Setting the target version to 6.0.0.

#6 - 2024-09-09 16:33 - Go MAEDA
- Status changed from New to Closed

- Assignee set to Go MAEDA

Committed the patch posted in #note-2 in r23046.

#7 - 2024-09-12 03:58 - Go MAEDA
- Target version deleted (6.0.0)

| found the change broke the filters and reverted the change in r23054.

#8 - 2024-09-12 04:58 - Yuichi HARADA
- File 32523-v3.patch added

It seems that the contents of #note-2 and r23054 are different.

| recreated the patch.

#9 - 2024-10-03 04:19 - Go MAEDA
- Status changed from Closed to Reopened

- Target version set to 6.0.0

#10 - 2024-10-04 00:37 - Go MAEDA

- Status changed from Reopened to Closed

Committed the patch posted as #note-8 in r23102. Thank you.

Files

javascript-perf.diff
javascript-perf2.diff
execution_speed_measurement.png
32523-note-2.patch

32523-v3.patch

2025-05-01

1.85 KB
1.85 KB
223 KB
2.51 KB
2.57 KB

2019-11-27
2019-11-29
2019-12-10
2024-09-05
2024-09-12

Stéphane Parunakian
Stéphane Parunakian
Yuichi HARADA

Go MAEDA

Yuichi HARADA

/4


https://www.redmine.org/issues/32523#note-2
https://www.redmine.org/projects/redmine/repository/svn/revisions/23046
https://www.redmine.org/projects/redmine/repository/svn/revisions/23054
https://www.redmine.org/projects/redmine/repository/svn/revisions/23054
https://www.redmine.org/projects/redmine/repository/svn/revisions/23102
http://www.tcpdf.org

